<?php
/**
 * Catch Everest Custom meta box
 *
 * @package Catch Themes
 * @subpackage Catch_Everest
 * @since Catch Everest 1.0
 */

 // Add the Meta Box
function catcheverest_add_custom_box() {
	add_meta_box(
		'catcheverest-options',							  	//Unique ID
       __( 'Catch Everest Options', 'catch-everest-pro' ),   	//Title
        'catcheverest_meta_options',                   	//Callback function
        'page'                                          	//show metabox in page
    );
	add_meta_box(
		'catcheverest-options',							  	//Unique ID
       __( 'Catch Everest Options', 'catch-everest-pro' ),   	//Title
        'catcheverest_meta_options',                   	//Callback function
        'post'                                          	//show metabox in post
    );
}
add_action( 'add_meta_boxes', 'catcheverest_add_custom_box' );


//Header Featured Image Options
global $header_image_options;
$header_image_options = array(
	'default' => array(
		'id'		=> 'catcheverest-header-image',
		'value' 	=> 'default',
		'label' 	=> __( 'Default', 'catch-everest-pro' ),
	),
	'enable' => array(
		'id'		=> 'catcheverest-header-image',
		'value' 	=> 'enable',
		'label' 	=> __( 'Enable', 'catch-everest-pro' ),
	),
	'disable' => array(
		'id'		=> 'catcheverest-header-image',
		'value' 	=> 'disable',
		'label' 	=> __( 'Disable', 'catch-everest-pro' )
	)
);


//Sidebar Layout Options
global $sidebar_layout;
$sidebar_layout = array(
		 'default-sidebar' => array(
            			'id'		=> 'catcheverest-sidebarlayout',
						'value' 	=> 'default',
						'label' 	=> __( 'Default Layout Set in', 'catch-everest-pro' ).' <a href="' . admin_url('themes.php?page=theme_options') . '" target="_blank">'. __( 'Theme Options', 'catch-everest-pro' ).'</a>',
						'thumbnail' => ' '
        			),
       'right-sidebar' => array(
						'id' => 'catcheverest-sidebarlayout',
						'value' => 'right-sidebar',
						'label' => __( 'Right sidebar', 'catch-everest-pro' ),
						'thumbnail' => trailingslashit( esc_url ( get_template_directory_uri() ) ) . 'inc/panel/images/right-sidebar.png'
       				),
        'left-sidebar' => array(
            			'id'		=> 'catcheverest-sidebarlayout',
						'value' 	=> 'left-sidebar',
						'label' 	=> __( 'Left sidebar', 'catch-everest-pro' ),
						'thumbnail' => trailingslashit( esc_url ( get_template_directory_uri() ) ) . 'inc/panel/images/left-sidebar.png'
       				),
        'no-sidebar' => array(
            			'id'		=> 'catcheverest-sidebarlayout',
						'value' 	=> 'no-sidebar',
						'label' 	=> __( 'No sidebar', 'catch-everest-pro' ),
						'thumbnail' => trailingslashit( esc_url ( get_template_directory_uri() ) ) . 'inc/panel/images/no-sidebar.png'
        			),
		'no-sidebar-full-width' => array(
            			'id'		=> 'catcheverest-sidebarlayout',
						'value' 	=> 'no-sidebar-full-width',
						'label' 	=> __( 'No sidebar, Full Width', 'catch-everest-pro' ),
						'thumbnail' => trailingslashit( esc_url ( get_template_directory_uri() ) ) . 'inc/panel/images/no-sidebar-fullwidth.png'
        			),
        'no-sidebar-one-column' => array(
            			'id'		=> 'catcheverest-sidebarlayout',
						'value' 	=> 'no-sidebar-one-column',
						'label' 	=> __( 'No Sidebar, One Column', 'catch-everest-pro' ),
						'thumbnail' => trailingslashit( esc_url ( get_template_directory_uri() ) ) . 'inc/panel/images/one-column.png'
        			)

    );


//Sidebar Options
global $sidebar_options;
$sidebar_options = array(
	'main-sidebar' => array(
		'id'		=> 'catcheverest-sidebar-options',
		'value' 	=> 'default-sidebar',
		'label' 	=> __( 'Default Sidebar', 'catch-everest-pro' )
	),
	'optional-sidebar-one' => array(
		'id' => 'catcheverest-sidebar-options',
		'value' => 'optional-sidebar-one',
		'label' => __( 'Optional Sidebar One', 'catch-everest-pro' )
	),
	'optional-sidebar-two' => array(
		'id' => 'catcheverest-sidebar-options',
		'value' => 'optional-sidebar-two',
		'label' => __( 'Optional Sidebar Two', 'catch-everest-pro' )
	),
	'optional-sidebar-three' => array(
		'id' => 'catcheverest-sidebar-options',
		'value' => 'optional-sidebar-three',
		'label' => __( 'Optional Sidebar three', 'catch-everest-pro' )
	)
);


//Featured Image Options
global $featuredimage_options;
$featuredimage_options = array(
	'default' => array(
		'id'		=> 'catcheverest-featured-image',
		'value' 	=> 'default',
		'label' 	=> __( 'Default Layout Set in', 'catch-everest-pro' ).' <a href="' . admin_url('themes.php?page=theme_options') . '" target="_blank">'. __( 'Theme Options', 'catch-everest-pro' ).'</a>',
	),
	'featured' => array(
		'id'		=> 'catcheverest-featured-image',
		'value' 	=> 'featured',
		'label' 	=> __( 'Featured Image', 'catch-everest-pro' )
	),
	'full' => array(
		'id' => 'catcheverest-featured-image',
		'value' => 'full',
		'label' => __( 'Full Image', 'catch-everest-pro' )
	),
	'slider' => array(
		'id' => 'catcheverest-featured-image',
		'value' => 'slider',
		'label' => __( 'Slider Image', 'catch-everest-pro' )
	),
	'disable' => array(
		'id' => 'catcheverest-featured-image',
		'value' => 'disable',
		'label' => __( 'Disable Image', 'catch-everest-pro' )
	)
);


/**
 * @renders metabox to for sidebar layout
 */
function catcheverest_meta_options() {
    global $header_image_options, $sidebar_layout, $sidebar_options, $featuredimage_options, $post;


    // Use nonce for verification
    wp_nonce_field( basename( __FILE__ ), 'custom_meta_box_nonce' );

    // Begin the field table and loop  ?>
    <div class="catcheverest-meta" style="border-bottom: 2px solid #dfdfdf; margin-bottom: 10px; padding-bottom: 10px;">
    	<h4 class="title"><?php _e('Sidebar Layout', 'catch-everest-pro'); ?></h4>
        <table id="sidebar-layout" class="form-table" width="100%">
            <tbody>
                <tr>
                    <?php
                    foreach ($sidebar_layout as $field) {
                        $metalayout = get_post_meta( $post->ID, $field['id'], true );
                        if (empty( $metalayout ) ){
                            $metalayout='default';
                        }
                        if ( $field['thumbnail']==' ' ): ?>
                                <label class="description">
                                    <input type="radio" name="<?php echo $field['id']; ?>" value="<?php echo $field['value']; ?>" <?php checked( $field['value'], $metalayout ); ?>/>&nbsp;&nbsp;<?php echo $field['label']; ?>
                                </label>
                        <?php else: ?>
                            <td>
                                <label class="description">
                                    <span><img src="<?php echo esc_url( $field['thumbnail'] ); ?>" width="136" height="122" alt="" /></span></br>
                                    <input type="radio" name="<?php echo $field['id']; ?>" value="<?php echo $field['value']; ?>" <?php checked( $field['value'], $metalayout ); ?>/>&nbsp;&nbsp;<?php echo $field['label']; ?>
                                </label>
                            </td>
                        <?php endif;
                    } // end foreach
                    ?>
                </tr>
            </tbody>
        </table>
   	</div><!-- .catcheverest-meta -->

    <div class="catcheverest-meta" style="border-bottom: 2px solid #dfdfdf; margin-bottom: 10px; padding-bottom: 10px;">
    	<h4 class="title"><?php _e('Select Sidebar', 'catch-everest-pro'); ?></h4>
        <table id="sidebar-select" class="form-table" width="100%">
            <tbody>
                <tr>
                    <?php
                    foreach ($sidebar_options as $field) {

                        $metasidebar = get_post_meta( $post->ID, $field['id'], true );

                        if (empty( $metasidebar ) ){
                            $metasidebar='default-sidebar';
                        } ?>
                        <td style="max-width: 100px; vertical-align: top;">
                            <label class="description">
                                <input type="radio" name="<?php echo $field['id']; ?>" value="<?php echo $field['value']; ?>" <?php checked( $field['value'], $metasidebar ); ?>/>&nbsp;&nbsp;<?php echo $field['label']; ?>
                            </label>
                        </td>

                        <?php
                    } // end foreach
                    ?>
                </tr>
            </tbody>
        </table>
	</div><!-- .catcheverest-meta -->

    <div class="catcheverest-meta" style="border-bottom: 2px solid #dfdfdf; margin-bottom: 10px; padding-bottom: 10px;">
    	<h4 class="title"><?php _e('Header Featured Image Options', 'catch-everest-pro'); ?></h4>
        <table id="featuedimage-metabox" class="form-table" width="100%">
            <tbody>
                <tr>
                    <?php
                    foreach ($header_image_options as $field) {

					 	$metaheader = get_post_meta( $post->ID, $field['id'], true );

                        if (empty( $metaheader ) ){
                            $metaheader='default';
                        } ?>

                        <td style="width: 100px;">
                            <label class="description">
                                <input type="radio" name="<?php echo $field['id']; ?>" value="<?php echo $field['value']; ?>" <?php checked( $field['value'], $metaheader ); ?>/>&nbsp;&nbsp;<?php echo $field['label']; ?>
                            </label>
                        </td>

                        <?php
                    } // end foreach
                    ?>
                </tr>
            </tbody>
        </table>
	</div><!-- .catcheverest-meta -->

    <div class="catcheverest-meta">
    	<h4 class="title"><?php _e('Content Featured Image Options', 'catch-everest-pro'); ?></h4>
        <table id="featuedimage-metabox" class="form-table" width="100%">
            <tbody>
                <tr>
                    <?php
                    foreach ($featuredimage_options as $field) {

					 	$metaimage = get_post_meta( $post->ID, $field['id'], true );

                        if (empty( $metaimage ) ){
                            $metaimage='default';
                        } ?>

                        <td style="width: 100px;">
                            <label class="description">
                                <input type="radio" name="<?php echo $field['id']; ?>" value="<?php echo $field['value']; ?>" <?php checked( $field['value'], $metaimage ); ?>/>&nbsp;&nbsp;<?php echo $field['label']; ?>
                            </label>
                        </td>

                        <?php
                    } // end foreach
                    ?>
                </tr>
            </tbody>
        </table>
	</div><!-- .catcheverest-meta -->

<?php
}


/**
 * save the custom metabox data
 * @hooked to save_post hook
 */
function catcheverest_save_custom_meta( $post_id ) {
	global $header_image_options, $sidebar_layout, $sidebar_options, $featuredimage_options, $post;

	// Verify the nonce before proceeding.
    if ( !isset( $_POST[ 'custom_meta_box_nonce' ] ) || !wp_verify_nonce( $_POST[ 'custom_meta_box_nonce' ], basename( __FILE__ ) ) )
        return;

	// Stop WP from clearing custom fields on autosave
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE)
        return;

	if ('page' == $_POST['post_type']) {
        if (!current_user_can( 'edit_page', $post_id ) )
            return $post_id;
    } elseif (!current_user_can( 'edit_post', $post_id ) ) {
            return $post_id;
    }


	foreach ( $header_image_options as $field ) {
		//Execute this saving function
		$old = get_post_meta( $post_id, $field['id'], true);
		$new = $_POST[$field['id']];
		if ($new && $new != $old) {
			update_post_meta($post_id, $field['id'], $new);
		} elseif ('' == $new && $old) {
			delete_post_meta($post_id, $field['id'], $old);
		}
	 } // end foreach


	foreach ($sidebar_layout as $field) {
		//Execute this saving function
		$old = get_post_meta( $post_id, $field['id'], true);
		$new = $_POST[$field['id']];
		if ($new && $new != $old) {
			update_post_meta($post_id, $field['id'], $new);
		} elseif ('' == $new && $old) {
			delete_post_meta($post_id, $field['id'], $old);
		}
	 } // end foreach

	foreach ( $sidebar_options as $field ) {
		//Execute this saving function
		$old = get_post_meta( $post_id, $field['id'], true);
		$new = $_POST[$field['id']];
		if ($new && $new != $old) {
			update_post_meta($post_id, $field['id'], $new);
		} elseif ('' == $new && $old) {
			delete_post_meta($post_id, $field['id'], $old);
		}
	 } // end foreach

	foreach ( $featuredimage_options as $field ) {
		//Execute this saving function
		$old = get_post_meta( $post_id, $field['id'], true);
		$new = $_POST[$field['id']];
		if ($new && $new != $old) {
			update_post_meta($post_id, $field['id'], $new);
		} elseif ('' == $new && $old) {
			delete_post_meta($post_id, $field['id'], $old);
		}
	 } // end foreach

}
add_action('save_post', 'catcheverest_save_custom_meta');
